Package com.sas.metadata.remote

# Interface Phone

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface Phone extends SecondaryType
A phone number and the type of phone number (home, office, mobile, fax).

Attributes of Phone are:

- `Number`
- `PhoneType`

Associations of Phone are:

- `Persons`

## Usage

To create an instance of this Phone, use the `factory` create methods.
Example: create a Phone with name "Phone_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Phone myObject = (Phone) factory.createComplexMetadataObject(objectStore, "Phone_Object", MetadataObjects.PHONE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_PERSONS_NAME`
  Constant used for the name of the Persons association.
  `static final String`
  `ATTRIBUTE_NUMBER_NAME`
  Constant used for the name of the Number attribute.
  `static final String`
  `ATTRIBUTE_PHONETYPE_NAME`
  Constant used for the name of the PhoneType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getNumber()`
  Gets the `String` value of `Number`
  `int`
  `getNumberMaxLength()`
  Gets the maximum length of `Number`
  `int`
  `getNumberState()`
  Gets the Metadata State of `Number`
  `AssociationList`
  `getPersons()`
  Gets the Association list of `Persons`
  `AssociationList`
  `getPersons(boolean fGoToServer)`
  Gets the Associationlist of `Persons`
  `String`
  `getPhoneType()`
  Gets the `String` value of `PhoneType`
  `int`
  `getPhoneTypeMaxLength()`
  Gets the maximum length of `PhoneType`
  `int`
  `getPhoneTypeState()`
  Gets the Metadata State of `PhoneType`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setNumber(String inNumber)`
  Sets the `Number` value and sets the state to MetadataState.LOCAL.
  `void`
  `setNumber(String inNumber, int state)`
  Sets the `Number` Metadata State.
  `void`
  `setNumberState(int state)`
  Sets the Metadata State of `Number`.
  `void`
  `setPersons(AssociationList list)`
  Sets the `Persons` list to be `list`.
  `void`
  `setPersons(AssociationList inObjects, int state)`
  Sets the entire Persons list to match the passed in AssociationList, sets the state of the Persons
  `void`
  `setPhoneType(String inPhoneType)`
  Sets the `PhoneType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPhoneType(String inPhoneType, int state)`
  Sets the `PhoneType` Metadata State.
  `void`
  `setPhoneTypeState(int state)`
  Sets the Metadata State of `PhoneType`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_NUMBER_NAME

    static final String ATTRIBUTE_NUMBER_NAME
    Constant used for the name of the Number attribute.

    Number: A phone number.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PHONETYPE_NAME

    static final String ATTRIBUTE_PHONETYPE_NAME
    Constant used for the name of the PhoneType attribute.

    PhoneType: The type of phon number: home, office, mobile, fax, etc.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PERSONS_NAME

    static final String ASSOCIATION_PERSONS_NAME
    Constant used for the name of the Persons association.

    Persons: *Unknown*

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNumber

    String getNumber() throws RemoteException
    Gets the `String` value of `Number`
    Returns:
      The `Number`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNumberState

    int getNumberState() throws RemoteException
    Gets the Metadata State of `Number`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNumberMaxLength

    int getNumberMaxLength() throws RemoteException
    Gets the maximum length of `Number`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPhoneType

    String getPhoneType() throws RemoteException
    Gets the `String` value of `PhoneType`
    Returns:
      The `PhoneType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPhoneTypeState

    int getPhoneTypeState() throws RemoteException
    Gets the Metadata State of `PhoneType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPhoneTypeMaxLength

    int getPhoneTypeMaxLength() throws RemoteException
    Gets the maximum length of `PhoneType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPersons

    AssociationList getPersons() throws RemoteException, MdException
    Gets the Association list of `Persons`
    Returns:
      The AssociationList of `Persons` which can be of type:
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPersons

    AssociationList getPersons(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Persons`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Persons` which can be of type:
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setNumber

    void setNumber(String inNumber) throws RemoteException
    Sets the `Number` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inNumber` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumber

    void setNumber(String inNumber, int state) throws RemoteException
    Sets the `Number` Metadata State.
    Parameters:
      `inNumber` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberState

    void setNumberState(int state) throws RemoteException
    Sets the Metadata State of `Number`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPhoneType

    void setPhoneType(String inPhoneType) throws RemoteException
    Sets the `PhoneType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPhoneType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPhoneType

    void setPhoneType(String inPhoneType, int state) throws RemoteException
    Sets the `PhoneType` Metadata State.
    Parameters:
      `inPhoneType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPhoneTypeState

    void setPhoneTypeState(int state) throws RemoteException
    Sets the Metadata State of `PhoneType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPersons

    void setPersons(AssociationList list) throws RemoteException
    Sets the `Persons` list to be `list`. Objects of which can be of type:
    Person
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPersons

    void setPersons(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Persons list to match the passed in AssociationList, sets the state of the Persons
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.